#include "header\GBA.h"
#include "header\BG.h"
#include "header\Timer.h"
#include "header\DMA.h"
#include "header\IRQ.h"
#include "header\sound.h"
#include "header\sprite.h"

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <malloc.h>
#include "lib.h"
#include "iwram.h"
#include "syscall.h"

ST_FONTBITMAP FONTBITMAP;
ST_FONTSJIS   FONTSJIS;
ST_WAVE       WAVE;
ST_KEY        KEY;
ST_SEEK       SEEK;

extern u8 __ewram_overlay_lma;

//========================================================================
void WaitForVsync(void)
{
	while (*(volatile u16*)0x4000006 >= 160){};
	while (*(volatile u16*)0x4000006 < 160) {};
}
//========================================================================
u16 Mode3GetDotRGB(u8 x,u8 y)
{
	u16* Screen = VideoBuffer;
	return Screen[y*240+x];
}
//========================================================================
void Mode3DrawDot(u8 x,u8 y,u16 color)
{
	u16* Screen = VideoBuffer;
	Screen[y*240+x] = color;
}
//========================================================================
void Mode3DrawLine(u8 x1,u8 y1,u8 x2,u8 y2,u16 color)
{
	u16 x, y;
	double dx, dy;
	dx = abs(x2 - x1);
	dy = abs(y2 - y1);

	//XP菬ꍇ
	if(dx/dy>1)
	{
		//xɕ`
		for(x=x1; x<x2; x++)
		{
			y=(y2-y1)*(x-x1)/(x2-x1)+y1;
			Mode3DrawDot(x,y,color);
		}
	}
	else
	{
		//yɕ`
		for(y=y1; y<y2; y++)
		{
			x=(x2-x1)*(y-y1)/(y2-y1)+x1;
			Mode3DrawDot(x,y,color);
		}
	}
}
//========================================================================
void Mode3DrawBox(u8 x1,u8 y1,u8 x2,u8 y2,u16 color)
{
	u16* Screen = VideoBuffer;
	u8 x,y;

	for(y=y1; y<y1+y2; y++)
	{
		for(x=x1; x<x1+x2; x++)
		{
			Screen[y*240+x] = color;
		}
	}
}
//========================================================================
void Mode3DrawCls(u16 color)
{
	Mode3DrawBox(0,0,240,160,color);
}
//========================================================================
void Mode3DrawImage(u8 x1, u8 y1, u8 cx, u8 cy, u16* image)
{
	u16* Screen = VideoBuffer;
	u8 x,y;

	Screen += y1*240+x1;

	for(y=0; y<cy; y++)
	{
		for(x=0; x<cx; x++)
		{
			Screen[y*240+x] = image[y*240+x];
		}
	}
}
//========================================================================
void DMA3MemcpyFIX16(u32 src, u32 dest, u16 size)
{
	REG_DM3SAD   = src;            //]
	REG_DM3DAD   = dest;           //]
	REG_DM3CNT_L = size;           //]TCY u16Pʂ̐
	                               //][h 16bit ]tOON 
	                               //]^C~OɊJn s[hOFF
	                               //]Œ ]CN
	                               //f[^]A荞ݒ~
	REG_DM3CNT_H = (DMA_SIZE_16    | DMA_TRANSFER_ON |
	                DMA_TIMING_NOW | DMA_REPEAT_OFF  |
	                DMA_SAD_FIX    | DMA_DAD_INC     | DMA_INTR_OFF);

	while(REG_IF&IRQ_BIT_DMA3){}    //DMA]tO~܂Ń[v
}
//========================================================================
void DMA3MemcpyINC16(u32 src, u32 dest, u16 size)
{
	REG_DM3SAD   = src;            //]
	REG_DM3DAD   = dest;           //]
	REG_DM3CNT_L = size;           //]TCY u16Pʂ̐
	                               //][h 16bit ]tOON 
	                               //]^C~OɊJn s[hOFF
	                               //]CN ]CN
	                               //f[^]A荞ݒ~
	REG_DM3CNT_H = (DMA_SIZE_16    | DMA_TRANSFER_ON |
	                DMA_TIMING_NOW | DMA_REPEAT_OFF  |
	                DMA_SAD_INC    | DMA_DAD_INC     | DMA_INTR_OFF);

	while(REG_IF&IRQ_BIT_DMA3){}    //DMA]tO~܂Ń[v
}
//========================================================================
void DMA3MemcpyINC32(u32 src, u32 dest, u16 size)
{
	REG_DM3SAD   = src;            //]
	REG_DM3DAD   = dest;           //]
	REG_DM3CNT_L = size;           //]TCY u16Pʂ̐
	                               //][h 16bit ]tOON 
	                               //]^C~OɊJn s[hOFF
	                               //]Œ ]CN
	                               //f[^]A荞ݒ~
	REG_DM3CNT_H = (DMA_SIZE_32    | DMA_TRANSFER_ON |
	                DMA_TIMING_NOW | DMA_REPEAT_OFF  |
	                DMA_SAD_INC    | DMA_DAD_INC     | DMA_INTR_OFF);

	while(REG_IF&IRQ_BIT_DMA3){}    //DMA]tO~܂Ń[v
}
//========================================================================
void Mode3SetBitMapFont(u8 *p, u16 cx, u16 cy, u16 cnt)
{
	FONTBITMAP.offset  = p;
	FONTBITMAP.cnt     = cnt;   //܂̂Ƃ͎gȂ
	FONTBITMAP.cx      = cx;
	FONTBITMAP.cy      = cy;
	FONTBITMAP.size    = cx*cy;
}
//========================================================================
void Mode3SetSJISFont(u32 code, u16 cnt, u32 offset, u8 cx, u8 cy)
{
	FONTSJIS.Code    = (u16*)EtfsOffset(code);      //ƂȂtHgV[g
	FONTSJIS.Offset  = (u8 *)EtfsOffset(offset);    //tHgf[^
	FONTSJIS.cnt     = cnt/2;                              //tHg@u16Pʂ̏̂Ł`
	FONTSJIS.cx      = cx;                                 //PtHgx̃oCg
	FONTSJIS.cy      = cy;                                 //PtHgỹoCg
	FONTSJIS.size    = cx*cy;                              //PtHgByte
}
//========================================================================
void Mode3DrawBitMapChar(u8 x,u8 y,u16 chr)
{
	u16 *Screen = VideoBuffer;
	u16 *Offset = (u16*)FONTBITMAP.offset;
	u8 i,j;

	Screen += FONTBITMAP.cx*x + FONTBITMAP.cy*y*240;
	Offset += FONTBITMAP.size * chr;

	for(i=0; i<FONTBITMAP.cy; i++)
	{
		for(j=0; j<FONTBITMAP.cx; j++)
		{
			Screen[i*240+j] = *Offset++;
		}
	}
}
//========================================================================
void Mode3DrawBitMapStr(u8 x,u8 y,u8* str)
{
	u16 c;
	u8 i=0,dx=0;

	while(str[i]!=0x00 && str[i]!=0x0a)
	{
		if(str[i]<=0x7f)	//1byte char
		{
			Mode3DrawBitMapChar(x+dx,y,(u16)str[i]);
			dx++; i++;
		}
		else
		{					//2byte char
			switch(str[i])
			{
				case 0x82: c = str[i+1]-0x90+192; break;
				case 0x83: c = str[i+1]-0x40+304; break;
				default  : c = str[i+1];          break;
			}
			Mode3DrawBitMapChar(x+dx,y,c);
			dx++; i+=2;
		}
	}
}
//========================================================================
void BGSetChrData(u8 No,u16 *img,u32 size)
{
	u16 *BGChr = MEM_BG_CHAR(No);
	u32 i;

	for(i=0; i<size/2; i++)
	{
		*BGChr++ = *img++;
	}
}
//========================================================================
void BGSetMapData(u8 No,u16 *img,u32 size)
{
	u16 *BGMap = MEM_BG_MAP(No);
	u32 i;

	for(i=0; i<size/2; i++)
	{
		*BGMap++ = *img++;
	}
}
//========================================================================
void BGSetPalMap(u8 No,u32 size, u16 pal)
{
	u16 *BGMap = MEM_BG_MAP(No);
	u32 i;

	for(i=0; i<size/2; i++)
	{
		*BGMap++ |= pal<<12;
	}
}
//========================================================================
void BGSetPal16(u16 No, u16 *pal)
{
	u16 *BGPal = MEM_BG_PAL;
	u16 i;

	BGPal += 16*No;

	for(i=0; i<16; i++)
	{
		*BGPal++ = *pal++;
	}
}
//========================================================================
void BGSetPal256(u16 *pal)
{
	u16 *BGPal = MEM_BG_PAL;
	u16 i;
	
	for(i=0; i<256; i++)
	{
		*BGPal++ = *pal++;
	}
}
//========================================================================
void BGDrawStr(u8 BG,u8 x,u8 y,u8* str)
{
	u16 c;
	u8 i=0,dx=0;

	while(str[i]!=0x00 && str[i]!=0x0a)
	{
		if(str[i]<=0x7f)	//1bytechar
		{
			BGDrawChar(BG,x+dx,y,0,(u16)str[i]);
			dx++; i++;
		}
		else				//2bytechar
		{
			switch(str[i])
			{
				case 0x82: c = str[i+1]-0x90+192; break;
				case 0x83: c = str[i+1]-0x40+304; break;
				default  : c = str[i+1];          break;
			}
			BGDrawChar(BG,x+dx,y,0,c);
			dx++; i+=2;
		}
	}
}
//========================================================================
void BGDrawChar(u8 No, u8 x,u8 y,u16 palno,u16 chr)
{
	u16 *BGMap = MEM_BG_MAP(No);
	BGMap += y*32+x;
	*BGMap = chr+(palno<<12);
}
//========================================================================
//BG 256*256ΉĂȂ
void BGDrawCls(u8 BG, u16 chr)
{
	u16 *BGMap = MEM_BG_MAP(BG);
	u16 i;

	for(i=0; i<32*32; i++)
	{
		*(BGMap+i) = chr;
	}
}
//========================================================================
//BG 256*256ΉĂȂ
void BGDrawBox(u8 BG, u16 x, u16 y, u16 stopX, u16 stopY, u16 chr)
{
	u16 *BGMap = MEM_BG_MAP(BG);
	int j,k;

	BGMap += x * 0x04;	//x
	BGMap += y * 0x80;	//y

	for(j=0; j<stopY; j++)
	{
		for(k=0; k<stopX; k++)
		{
			*(BGMap+k) = 0x0090;
		}
		BGMap += 0x20;
	}
}
//========================================================================
void SpriteInitialize()
{
	u16 i;

	for(i=0; i<128; i++)
	{
		SpriteMove(i, 240, 160);  //Display̕\O
	}
}
//========================================================================
void SpriteMove(u16 num, s16 x, s16 y)
{
	OAMEntry* sp = (OAMEntry*)OAMmem;      // OAM
	sp += num;                             // OAM̍\Pʂ8byte
//  if(x<0) x += 512;
//  if(y<0) y += 256;
	sp->attribute1 &= 0xfe00;
	sp->attribute0 &= 0xff00;
	sp->attribute1 |= (x & 0x01ff);
	sp->attribute0 |= (y & 0x00ff);
}
//========================================================================
void SpriteSetPal16No(u16 num, u16 palno)
{
	OAMEntry* sp = (OAMEntry*)OAMmem;      // OAM
	sp += num;                             // OAM̍\Pʂ8byte
	palno &= 0x000f;
	sp->attribute2 &= 0x0fff;
	sp->attribute2 |= (palno<<12);
}
//========================================================================
/*	XvCǧ`ݒ
	spEEE ύXXvCgw
	sizeEE SP_SIZE_8,SP_SIZE_16,SP_SIZE_32,SP_SIZE_64
	formEE SP_SQUARE,SP_TALL,SP_WIDE
	colorEESP_COLOR_16, SP_COLOR_256  */
void SpriteSetSize(u16 num,u16 size,u16 form,u16 color)
{
	OAMEntry* sp = (OAMEntry*)OAMmem;      // OAM
	sp += num;                             // OAM̍\Pʂ8byte
	sp->attribute0 &= 0x1FFF;
	sp->attribute0 |= color | form | (160);
	sp->attribute1 &= 0x3FFF;
	sp->attribute1 |= size | (240);
}
//========================================================================
void SpriteSetChr(u16 num, u16 ch)
{
	OAMEntry* sp = (OAMEntry*)OAMmem;      // OAM
	sp += num;                             // OAM̍\Pʂ8byte
	sp->attribute2 &= 0xFC00;
	sp->attribute2 |= ch;
}
//========================================================================
void SpriteSetPriority(u16 num, u16 priority)
{
	OAMEntry* sp = (OAMEntry*)OAMmem;      // OAM
	sp += num;                             // OAM̍\Pʂ8byte
	sp->attribute2 &= 0xF3FF;
	sp->attribute2 |= priority<<10;
}
//========================================================================
void SpriteSetVertical(u16 num, u8 flag)
{
	OAMEntry* sp = (OAMEntry*)OAMmem;      // OAM
	sp += num;                             // OAM̍\Pʂ8byte
	sp->attribute1 &= 0xEFFF;
	sp->attribute1 |= flag<<12;
}
//========================================================================
void SpriteSetData(u16 *img,u32 size)
{
	u16 *OAMDataAdr = OAMdata;
	u32 i;
	for(i=0; i<size/2; i++)
	{
		*OAMDataAdr++ = *img++;
	}
}
//========================================================================
void SpriteSetPal16(u16 *pal)
{
	u16* OBJPaleAdr = OBJpal;
	u16 i;
	for(i=0; i<16; i++)
	{
		*OBJPaleAdr++ = *pal++;
	}
}
//========================================================================
void SpriteSetPal256(u16 *pal)
{
	u16* OBJPaleAdr = OBJpal;
	u16 i;
	for(i=0; i<256; i++)
	{
		*OBJPaleAdr++ = *pal++;
	}
}
//========================================================================
char *bprintf(char *p, char *fmt, ...)
{
	va_list marker;
	va_start(marker, fmt);
	vsprintf(p, fmt, marker);
	va_end(marker);
	return p;
}
//========================================================================
int dprintf(char *fmt, ...)
{
	char s[256];
	va_list marker;
	va_start(marker, fmt);
	int r = vsprintf(s, fmt, marker);
	va_end(marker);
	dprint(s);
	return r;
}
//========================================================================
//VBÃfobNlogo͂
void dprint(u8 *sz)
{
  const u32 port=0xc0ded00d;
//	"ldr r0, =0xc0ded00d\n"
	asm volatile(
		"mov r2, %0\n"
		"mov r0, %1\n"
		"mov r1, #0\n"
		"and r0, r0, r0\n"
		:
		:
		"r" (sz) ,"r" (port):
		"r0", "r1", "r2");
}
//========================================================================
  //܂̂ƂPCM(8bit Wav)t
void SoundInitialize()
{
	SOUNDCNT_X  = ENABLE_SOUND_MASTER;
	SOUNDCNT_L  = 0;
	SOUNDCNT_H  = 0;
	SOUNDCNT_H |= (DSOUND_A_TIMER0 | ENABLE_DSOUND_A_RIGHT | ENABLE_DSOUND_A_LEFT | DSOUND_A_FULL_OUTPUT);
	SOUNDCNT_H |= (RESET_DSOUND_A);
}
//========================================================================
void SoundSetData(s8 *buf, u32 size)
{
	WAVE.Offset= buf;
	WAVE.size = size;
}
//========================================================================
void SoundStart()
{
	REG_TM0CNT   &= ~TM_ENABLE;
	REG_DM1CNT_H &= ~DMA_TRANSFER_ON;

	REG_DM1CNT_H = 0;
	REG_DM1SAD   = (u32)(WAVE.size);
	REG_DM1DAD   = (u32)(FIFO_A);
	REG_DM1CNT_H = (DMA_SIZE_32 | DMA_TRANSFER_OFF | DMA_TIMING_FIFO | 
	                DMA_REPEAT_ON | DMA_SAD_INC | DMA_DAD_FIX | DMA_INTR_ON);

	REG_TM0D = (u16)(-1520);
	REG_TM0CNT = TM_ENABLE | TM_FREQ_PER_1;

	REG_DM1CNT_H|= DMA_TRANSFER_ON;
}
//========================================================================
void *_malloc(u32 size)
{
	void *ptr;

	ptr=malloc(size);

	if(ptr!=0)
	{
		dprintf("_malloc ptr=0x%x size=0x%x \n",size,(u32)ptr);
		return(ptr);
	}

	REG_IME = IRQ_MASTER_OFF;
	dprintf("vIG[:EWRAMȂȂ܂B\n");
	dprintf("_malloc ptr=0x%x \n",(u32)ptr);

	for(;;){}
}
//========================================================================
void _mfree(void *ptr)
{
	dprintf("_mfree ptr=0x%x\n",(u32)ptr);
	free(ptr);
}
//========================================================================
// ExtendTinyFileSystem
u8* EtfsOffset(u32 data_offset)
{
	u8* ewram = ADR_EWRAM;
	ewram += data_offset;

	dprintf("EtfsOffset ptr=0x%x;\n",(u32)ewram);
	return(ewram);
}
//========================================================================
u8 EtfsReadu8(u32 data_offset)
{
	u8* ewram = ADR_EWRAM;
	ewram += data_offset;
	return(*ewram);
}
//========================================================================
u16 EtfsReadu16(u32 data_offset)
{
	u16* ewram = (u16*)ADR_EWRAM;
	ewram += data_offset;
	return(*ewram);
}
//========================================================================
u32 EtfsReadu32(u32 data_offset)
{
	u32* ewram = (u32*)ADR_EWRAM;
	ewram += data_offset;
	return(*ewram);
}
//========================================================================
u8 *EtfsfopenLZ77(u32 offset, u32 size)
{
	u8 *buf;
	buf = _malloc(size);

	//Bios Call
	LZ77UnCompWram((void*)EtfsOffset(offset), (void*)buf);
	return(buf);
}
//========================================================================
u8 *Etfsfopen(u32 offset, u32 size)
{
	u8 *buf;
	buf = _malloc(size);
	//f[^Rs[@ĂȂ
	return(buf);
}
//========================================================================
void EtfsSeekSet(u32 offset, u32 size, u8 token)
{
	u8* ewram    = ADR_EWRAM;
	u8* ewramEnd = ADR_EWRAM;

	ewram    += offset;
	ewramEnd += offset + size;

	SEEK.Offset    = ewram;
	SEEK.OffsetEnd = ewramEnd;
	SEEK.Token     = token;
}
//========================================================================
u8*  EtfsSeekNext()
{
	while(SEEK.Offset < SEEK.OffsetEnd)
	{
		SEEK.Offset++;
		if(*SEEK.Offset == SEEK.Token)
		{
			return SEEK.Offset;
		}
	}
	return 0;
}
//========================================================================
u8*  EtfsSeekPrev()
{
	//
	return 0;
}
//========================================================================
u8   EtfsSeekHasMore()
{
	u8* Offset = SEEK.Offset;
	while(Offset < SEEK.OffsetEnd)
	{
		Offset++;
		if(*Offset == SEEK.Token)
		{
			return 1;
		}
	}
	return 0;
}
//========================================================================
// 1bittHgf[^16hbg\
void Mode3DrawSJISBlock(u8 font,int x,int y,u16 color)
{
	u16* screen = VideoBuffer;

	screen[(y*240)+(x+0)] = (font & 0x80) ? color : screen[(y*240)+(x+0)];
	screen[(y*240)+(x+1)] = (font & 0x40) ? color : screen[(y*240)+(x+1)];
	screen[(y*240)+(x+2)] = (font & 0x20) ? color : screen[(y*240)+(x+2)];
	screen[(y*240)+(x+3)] = (font & 0x10) ? color : screen[(y*240)+(x+3)];
	screen[(y*240)+(x+4)] = (font & 0x08) ? color : screen[(y*240)+(x+4)];
	screen[(y*240)+(x+5)] = (font & 0x04) ? color : screen[(y*240)+(x+5)];
	screen[(y*240)+(x+6)] = (font & 0x02) ? color : screen[(y*240)+(x+6)];
	screen[(y*240)+(x+7)] = (font & 0x01) ? color : screen[(y*240)+(x+7)];
}
//========================================================================
// tHgf[^̐擪numberԖڂ̂P\
void Mode3DrawSJISAscii(u8 x, u8 y, u16 num, u16 col)
{
//	int index = (num/32*64 + num%32);

//	Set1block1bit(screen,(u8*)&HANKAKU_FONT[index*8        ],x1  ,y1  ,color);
//	Set1block1bit(screen,(u8*)&HANKAKU_FONT[index*8   +32*8],x1  ,y1+8,color);
}
//========================================================================
// tHgf[^̐擪numberԖڂ̂P\
void Mode3DrawSJISChar(u8 x, u8 y, u16 num, u16 col)
{
	u32 index = num * FONTSJIS.size;
	u8  i,j;

	for(j=0; j<FONTSJIS.cy; j++)
	{
		for(i=0; i<FONTSJIS.cx; i++)
		{
			Mode3DrawSJISBlock(FONTSJIS.Offset[index++],x+i*8, y+j, col);
		}
	}
}
//========================================================================
// Spꕶ\
void Mode3DrawSJIS(u8 x, u8 y, u8* chr, u16 col)
{
	u16 code = (chr[1]*256) + chr[0]; //tɂƂ
	u16 i;

	for(i=0; i<FONTSJIS.cnt; i++)
	{
		if(code == FONTSJIS.Code[i])
		{
			//fWXȏEE
			i -= (i/0x21);		//'\n'Ȃ
			Mode3DrawSJISChar(x,y,i,col);
		}
	}
}
//========================================================================
void Mode3DrawSJISStr(u8 x,u8 y,u8 *text,u16 col)
{
	u16 i=0;
	
	while( text[i] != '\0' )
	{
		if( text[i] >= 0x80 )	//Sp
		{
			Mode3DrawSJIS(x,y,&text[i],col);
			i+=2; x+=14;
		}
		else
		{						//p
			Mode3DrawSJISAscii(x,y,text[i],col);
			i+=1; x+=1;
		}
	}
}
//========================================================================
void WaitKey(u16 waitkey)
{
	REG_TM2CNT = 0;
	REG_TM2CNT = TM_FREQ_PER_1 | TM_ENABLE;

	for(;;)
	{
		if( !(*KEYS & waitkey) )
		{
			break;
		}
	}

	srand(REG_TM2D);

	REG_TM2CNT = 0;
	REG_TM2D   = 0;
}
//========================================================================
u16 KeyInput()
{
	KEY.Prev = KEY.New;
	KEY.New  = *KEYS   ^ 0x3ff;
	KEY.Late = KEY.New ^ (KEY.Prev & KEY.New);

	return KEY.Late;
}
//========================================================================
void KeyInitialize()
{
	KEY.Prev = 0;
	KEY.New  = 0;
	KEY.Late = 0;
}
