#include "header\GBA.h"
#include "header\BG.h"
#include "header\Timer.h"
#include "header\DMA.h"
#include "header\IRQ.h"
#include "header\sound.h"
#include "header\sprite.h"
#include "header\Blend.h"

#include "lib.h"
#include "iwram.h"
#include "irq.h"
#include "syscall.h"

#include "data.h"

//#include "resource\BitStageFont.h"
#include "resource\BGFont.h"

#include <stdlib.h>

//const int __gba_multiboot;	//GBANp

//BG2    
//BG3    wiAAvC[

#define TRUE  (1)
#define FALSE (0)

#define STAGE_MAX_X   29
#define STAGE_MAX_Y   19
#define STAGE_MAX_CNT 30

//BG\ɎgLN^[
#define BG_CHR_BLANK  0x0000		// ' '  
#define BG_CHR_BOX    0x0001		// '$'  
#define BG_CHR_PUTBOX 0x0002		// '*'  uς
#define BG_CHR_PLACE  0x0003		// '.'  uꏊ
#define BG_CHR_WALL   0x0004		// '#'  
#define BG_CHR_PLAYER 0x0006		// '@'  vC[
#define BG_CHR_ERROR  0x0000		//      G[p
//---------------------------------------------------------------------------
typedef struct {
	u8  x;
	u8  y;
}ST_PLAYER;

ST_PLAYER PLAYER;
//---------------------------------------------------------------------------
u8 BG2Chr;
u8 BG2Map;
u8 BG2Col;

u8 BG3Chr;
u8 BG3Map;
u8 BG3Col;

u8 StageClearFlag;	//rs`fdItO
u8 StageCnt;		//H̃Xe[W
u8 WalkCnt;			//s

u8 GameStage[STAGE_MAX_X][STAGE_MAX_Y];	//Q[@Ɏg}bvf[^
u8 DataStage[STAGE_MAX_X][STAGE_MAX_Y];	//ǂݍ݂Ɏg}bvf[^
//---------------------------------------------------------------------------
void Init();
void InitBG();
void InitGame();
void InitStage();

void LoadGameStage();
void LoadReadStage();

void RestStage();

void InputPlayer();
void CalcPlayer(u8,u8);

void MovePlayer(u8,u8);
void MoveBox(u8,u8,u8,u8);

void DrawPlayer();
void DrawScore();
void DrawStage();
void DrawBlock(u8,u8);

void ChkStageClear();
//---------------------------------------------------------------------------
int main(void)
{
	Init();
	InitBG();
	SetMode(MODE_0 | BG2_ENABLE | BG3_ENABLE);

	for(;;)
	{
		if(StageCnt++ >= STAGE_MAX_CNT)
		{
			break;
		}

		//Xe[W
		InitGame();
		InitStage();
		DrawScore();
		DrawStage();
		DrawPlayer();

		//Q[Jn
		while(StageClearFlag == FALSE)
		{
			InputPlayer();
			DrawScore();
			DrawPlayer();

			ChkStageClear();
		}
	} //for(;;)

	BGDrawStr(BG2Map, 2, 14, " --- Game Clear! --- ");
	for(;;){}

	return 0;
}
//---------------------------------------------------------------------------
void Init()
{
	StageCnt = 0;
	EtfsSeekSet(_SOKOBAN_MAP_BIN_OFFSET, _SOKOBAN_MAP_BIN_SIZE, ';');
}
//---------------------------------------------------------------------------
void InitGame()
{
	PLAYER.x     = 0;
	PLAYER.y     = 0;
	WalkCnt      = 0;
	StageClearFlag = FALSE;

	BGDrawCls(BG2Map, 0x0000);
	BGDrawCls(BG3Map, 0x0005);
}
//---------------------------------------------------------------------------
void InitBG()
{
	//BG2 
	//BG3 wiAAvC[

	BG2Map = 0;
	BG3Map = 1;

	BG2Chr = 1;
	BG3Chr = 2;

	BG2Col = 0;
	BG3Col = 1;

	REG_BG2CNT = (BG_SIZEA_256_256    | BG_COLOR_16        |
				  BG_CHARBASE(BG2Chr) | BG_MAPBASE(BG2Map) | 0);
	REG_BG3CNT = (BG_SIZEA_256_256    | BG_COLOR_16        |
				  BG_CHARBASE(BG3Chr) | BG_MAPBASE(BG3Map) | 0);

	//Palette
	BGSetPal16(BG2Col, (u16*)BGFont_palette);
	BGSetPal16(BG3Col, (u16*)EtfsOffset(_BACKGROUND_IMG_PAL_OFFSET));

	//ChrData
	BGSetChrData(BG2Chr, (u16*)BGFont_data, BGFont_DATA_SIZE);
	BGSetChrData(BG3Chr, (u16*)EtfsOffset(_BACKGROUND_IMG_BIN_OFFSET), _BACKGROUND_IMG_BIN_SIZE);
}
//---------------------------------------------------------------------------
void InputPlayer()
{
	u8 Key;
	KeyInitialize();

	for(;;)
	{
		Key = KeyInput();
		
		if(Key & KEY_UP   ) { CalcPlayer(PLAYER.x,   PLAYER.y-1); break; }
		if(Key & KEY_DOWN ) { CalcPlayer(PLAYER.x,   PLAYER.y+1); break; }
		if(Key & KEY_LEFT ) { CalcPlayer(PLAYER.x-1, PLAYER.y);   break; }
		if(Key & KEY_RIGHT) { CalcPlayer(PLAYER.x+1, PLAYER.y);   break; }
		if(Key & KEY_B)     { RestStage(); break; }
		if(Key & KEY_A)     { StageClearFlag = TRUE; break; }

	}

	while(*KEYS != 0x3ff){}		//͂ɂȂ܂ő҂
}
//---------------------------------------------------------------------------
void MovePlayer(u8 x, u8 y)
{
	//ړǑn
	DrawBlock(PLAYER.x, PLAYER.y);

	PLAYER.x = x;
	PLAYER.y = y;
	WalkCnt++;
}
//---------------------------------------------------------------------------
//vC[̈ړɂ郂mɂāA𕪊򂳂
void CalcPlayer(u8 moveX, u8 moveY)
{
	//ړ͉邩i[
	u8 moveR = GameStage[moveX][moveY];

	//ǂ
	if(moveR == '#')
	{
		return;
	}
	// or i[ꏊ
	if(moveR == ' ' || moveR == '.')
	{
		MovePlayer(moveX, moveY);
		return;
	}
	// or i[ς݂
	if(moveR == '$' || moveR == '*')
	{
		//Ɏ̈ړ߂
		u8 nextMoveX = moveX + (moveX - PLAYER.x);
		u8 nextMoveY = moveY + (moveY - PLAYER.y);
		u8 nextMoveR = GameStage[nextMoveX][nextMoveY];

		// or i[ꏊ
		if(nextMoveR == ' ' || nextMoveR == '.')
		{
			MoveBox   (moveX, moveY, nextMoveX, nextMoveY);
			MovePlayer(moveX, moveY);
		}
	}
}
//---------------------------------------------------------------------------
void MoveBox(u8 srcX, u8 srcY, u8 destX, u8 destY)
{
	//ړO
	if(GameStage[srcX][srcY] ==  '*')   GameStage[srcX][srcY] = '.';
	else                                GameStage[srcX][srcY] = ' ';

	//ړ
	if(GameStage[destX][destY] ==  '.') GameStage[destX][destY] = '*';
	else                                GameStage[destX][destY] = '$';

	DrawBlock( srcX,  srcY);
	DrawBlock(destX, destY);
}
//---------------------------------------------------------------------------
void ChkStageClear()
{
	u8 x,y;
	for(y=0; y<STAGE_MAX_Y; y++)
	{
		for(x=0; x<STAGE_MAX_X; x++)
		{
			if(GameStage[x][y] == '.')
			{
				return;
			}
		}
	}
	StageClearFlag = TRUE;
}
//---------------------------------------------------------------------------
void DrawBlock(u8 x,u8 y)
{
	switch(GameStage[x][y])
	{
	case '*': BGDrawChar(BG3Map, x, y, BG3Col, BG_CHR_PUTBOX); break;
	case '$': BGDrawChar(BG3Map, x, y, BG3Col, BG_CHR_BOX);    break;
	case ' ': BGDrawChar(BG3Map, x, y, BG3Col, BG_CHR_BLANK);  break;
	case '.': BGDrawChar(BG3Map, x, y, BG3Col, BG_CHR_PLACE);  break;
	case '#': BGDrawChar(BG3Map, x, y, BG3Col, BG_CHR_WALL);   break;
	case '@': BGDrawChar(BG3Map, x, y, BG3Col, BG_CHR_PLAYER); break;

	default:
		BGDrawChar(BG3Map, x, y, BG3Col, BG_CHR_ERROR);
		dprintf("Error DrawBlock %d,%d \n", x, y);
		break;
	}
}
//---------------------------------------------------------------------------
void DrawPlayer()
{
	WaitForVsync();
	BGDrawChar(BG3Map, PLAYER.x, PLAYER.y, BG3Col, BG_CHR_PLAYER);
}
//---------------------------------------------------------------------------
void DrawScore()
{
	u8 Score[256];
	bprintf(Score, "STAGE:%2d WALK:%4d  ", StageCnt, WalkCnt);
	BGDrawStr(BG2Map, 0, 19, Score);
}
//---------------------------------------------------------------------------
void LoadMapData()
{
	u8* pData = EtfsSeekNext() + 8; //8͕␳ł

	dprintf("STAGE=%d pData=%x \n",StageCnt, pData);

	u8 x=0;
	u8 y=0;
	while(*pData != ';' && *pData != 0x0d && y < STAGE_MAX_Y)
	{
		DataStage[x][y] = *pData;
		x++; pData++;

		if(*pData == 0x0d)	//sR[h̏ꍇ
		{
			x=0;
			y++; pData+=2;
		}
	}
}
//---------------------------------------------------------------------------
void InitDataStage()
{
	u8 x,y;
	for(y=0; y<STAGE_MAX_Y; y++)
	{
		for(x=0; x<STAGE_MAX_X; x++)
		{
			DataStage[x][y] = ' ';
		}
	}
}
//---------------------------------------------------------------------------
void InitStage()
{
	InitDataStage();
	LoadMapData();
	
	u8 x,y;
	for(y=0; y<STAGE_MAX_Y; y++)
	{
		for(x=0; x<STAGE_MAX_X; x++)
		{
			GameStage[x][y] = DataStage[x][y];

			//vC[̖ڈ́A󔒂Ɉɂ
			if(GameStage[x][y] == '@')
			{
				GameStage[x][y] = ' ';
				PLAYER.x = x;
				PLAYER.y = y;
			}
		}
	}
}
//---------------------------------------------------------------------------
void DrawStage()
{
	u8 x,y;
	for(y=0; y<STAGE_MAX_Y; y++)
	{
		for(x=0; x<STAGE_MAX_X; x++)
		{
			DrawBlock(x, y);
		}
	}
}
//---------------------------------------------------------------------------
void RestStage()
{
	u8 x,y;
	for(y=0; y<STAGE_MAX_Y; y++)
	{
		for(x=0; x<STAGE_MAX_X; x++)
		{
			GameStage[x][y] = DataStage[x][y];

			//vC[̖ڈ́A󔒂Ɉɂ
			if(GameStage[x][y] == '@')
			{
				GameStage[x][y] = ' ';
				PLAYER.x = x;
				PLAYER.y = y;
			}
		}
	}

	WalkCnt = 0;

	DrawScore();
	DrawStage();
	DrawPlayer();
}
